

from filenames import *

class EliminatorVisitor(object):
    
    
    def prepare_approximated_files(self, figure):
        PERCENTAGE_PER_FILE = 5
        
        total = figure.TotalRemovablePoints
        remaining = figure.TotalRemovablePoints
        
        
        hundredth = total / 100
        
        rounded = hundredth * 100
        
        
        for i in range(total - rounded):
            print i
            self.eliminate(figure)
        
        
        number_of_steps = 100 / PERCENTAGE_PER_FILE
        
        
        new_file_name = Filenames.compressed_filename_string(figure.FileName, 100)
        figure.write_to_file(figure.FileName, new_file_name)
        
        
        
        
        for i in range(number_of_steps):
            print i
            for j in range(hundredth * PERCENTAGE_PER_FILE):
                print j,
                self.eliminate(figure)
            
            
            current_percentage_of_points_remaining = (number_of_steps - 1 - i) * PERCENTAGE_PER_FILE
            
            new_file_name = Filenames.compressed_filename_string(figure.FileName, current_percentage_of_points_remaining)
            figure.write_to_file(figure.FileName, new_file_name)
            print "written", new_file_name
            
            print i 
            
            
    def eliminate(self, figure):
        
        self.remove_redundant_point(figure)
        
        
    def remove_redundant_point(self, figure):
        
        candidates_list = []
        
        for joint in figure.joint_list:
            
            candidate = self.get_redundant_point_tuple(joint)
            
            if candidate != None:
            
                candidates_list.append(candidate)
               
                if abs(candidate[0]) < 0.00001:
                    
                    break
                
                
        candidates_list.sort()
        
        #tuple format (distance, joint)
        
        
        if len(candidates_list) > 0:
               
            joint = candidates_list[0][1]
            
           
            self.remove_chosen_point(joint)
    
        
        
    def get_redundant_point_tuple(self, joint):
        candidates_list = []
        
        for graph in joint.graphs:
            
            candidate = graph.get_redundant_point_tuple()
            
            if candidate != None:
            
                candidates_list.append((candidate[0], graph))
                if abs(candidate[0]) < 0.00001:
                    break
                
        candidates_list.sort()
        
        
        if len(candidates_list) > 0:
            self.chosen_graph = candidates_list[0][1]
            return (candidates_list[0][0], self)
    
        else:
            return None
    
    
    
    
    def remove_chosen_point(self, joint):
        self.chosen_graph.remove_chosen_point()
    
        
        
        
        